## putty 0.58

=== doc/Makefile ===
all: man index.html

# Decide on the versionid policy.
#
# If the user has passed in $(VERSION) on the command line (`make
# VERSION="Release 0.56"'), we use that as an explicit version
# string. Otherwise, we use `svnversion' to examine the checked-out
# documentation source, and if that returns a single revision
# number then we invent a version string reflecting just that
# number. Failing _that_, we resort to versionids.but which shows a
# $Id for each individual file.
#
# So here, we define VERSION using svnversion if it isn't already
# defined ...
ifndef VERSION
SVNVERSION=$(shell test -d .svn && svnversion .)
BADCHARS=$(findstring :,$(SVNVERSION))$(findstring S,$(SVNVERSION))
ifeq ($(BADCHARS),)
ifneq ($(SVNVERSION),)
ifneq ($(SVNVERSION),exported)
VERSION=Built from revision $(patsubst M,,$(SVNVERSION))
endif
endif
endif
endif
# ... and now, we condition our build behaviour on whether or not
# VERSION _is_ defined.
ifdef VERSION
VERSIONIDS=vstr
vstr.but: FORCE
	echo \\versionid $(VERSION) > vstr.but
FORCE:;
else
VERSIONIDS=vids
endif

CHAPTERS := $(SITE) blurb intro gs using config pscp psftp plink pubkey
CHAPTERS += pageant errors faq feedback licence udp pgpkeys
CHAPTERS += index $(VERSIONIDS)

INPUTS = $(patsubst %,%.but,$(CHAPTERS))

# This is temporary. Hack it locally or something.
HALIBUT = halibut

index.html: $(INPUTS)
	$(HALIBUT) --text --html --winhelp $(INPUTS)

putty.info: $(INPUTS)
	$(HALIBUT) --info $(INPUTS)

MKMAN = $(HALIBUT) --man=$@ mancfg.but $<
MANPAGES = putty.1 puttygen.1 plink.1 pscp.1 psftp.1 puttytel.1 pterm.1
man: $(MANPAGES)

putty.1: man-putt.but mancfg.but; $(MKMAN)
puttygen.1: man-pg.but mancfg.but; $(MKMAN)
plink.1: man-pl.but mancfg.but; $(MKMAN)
pscp.1: man-pscp.but mancfg.but; $(MKMAN)
psftp.1: man-psft.but mancfg.but; $(MKMAN)
puttytel.1: man-ptel.but mancfg.but; $(MKMAN)
pterm.1: man-pter.but mancfg.but; $(MKMAN)

clean:
	rm -f *.html *.txt *.hlp *.cnt *.1 *.info vstr.but

=== macosx/Makefile ===
# Makefile for putty under Mac OS X.
#
# This file was created by `mkfiles.pl' from the `Recipe' file.
# DO NOT EDIT THIS FILE DIRECTLY; edit Recipe or mkfiles.pl instead.
#
# Extra options you can set:
#
#  - VER=-DSNAPSHOT=1999-01-25
#      Generates executables whose About box report them as being a
#      development snapshot.
#
#  - VER=-DRELEASE=0.43
#      Generates executables whose About box report them as being a
#      release version.
#
#  - COMPAT=-DAUTO_WINSOCK
#      Causes PuTTY to assume that <windows.h> includes its own WinSock
#      header file, so that it won't try to include <winsock.h>.
#
#  - COMPAT=-DWINSOCK_TWO
#      Causes the PuTTY utilities to include <winsock2.h> instead of
#      <winsock.h>, except Plink which _needs_ WinSock 2 so it already
#      does this.
#
#  - COMPAT=-DNO_SECURITY
#      Disables Pageant's use of <aclapi.h>, which is not available
#      with some development environments (such as older versions of
#      the Cygwin/mingw GNU toolchain). This means that Pageant
#      won't care about the local user ID of processes accessing it; a
#      version of Pageant built with this option will therefore refuse
#      to run under NT-series OSes on security grounds (although it
#      will run fine on Win95-series OSes where there is no access
#      control anyway).
#
#  - COMPAT=-DNO_MULTIMON
#      Disables PuTTY's use of <multimon.h>, which is not available
#      with some development environments. This means that PuTTY's
#      full-screen mode (configurable to work on Alt-Enter) will
#      not behave usefully in a multi-monitor environment.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <multimon.h> is
#      known not to be available in Cygwin.
#
#  - COMPAT=-DNO_IPV6
#      Disables PuTTY's ability to make IPv6 connections, enabling
#      it to compile under development environments which do not
#      support IPv6 in their header files.
#
#  - COMPAT=-DMSVC4
#  - RCFL=-DMSVC4
#      Makes a couple of minor changes so that PuTTY compiles using
#      MSVC 4. You will also need /DNO_SECURITY and /DNO_MULTIMON.
#
#  - RCFL=-DASCIICTLS
#      Uses ASCII rather than Unicode to specify the tab control in
#      the resource file. Probably most useful when compiling with
#      Cygnus/mingw32, whose resource compiler may have less of a
#      problem with it.
#
#  - XFLAGS=-DTELNET_DEFAULT
#      Causes PuTTY to default to the Telnet protocol (in the absence
#      of Default Settings and so on to the contrary). Normally PuTTY
#      will default to SSH.
#
#  - XFLAGS=-DDEBUG
#      Causes PuTTY to enable internal debugging.
#
#  - XFLAGS=-DMALLOC_LOG
#      Causes PuTTY to emit a file called putty_mem.log, logging every
#      memory allocation and free, so you can track memory leaks.
#
#  - XFLAGS=-DMINEFIELD
#      Causes PuTTY to use a custom memory allocator, similar in
#      concept to Electric Fence, in place of regular malloc(). Wastes
#      huge amounts of RAM, but should cause heap-corruption bugs to
#      show up as GPFs at the point of failure rather than appearing
#      later on as second-level damage.
#
CC = $(TOOLPATH)gcc

CFLAGS = -O2 -Wall -Werror -g -I.././ -I../charset/ -I../windows/ -I../unix/ \
		-I../mac/ -I../macosx/
MLDFLAGS = -framework Cocoa
ULDFLAGS =

CFLAGS += -DMACOSX

all: PuTTY plink pscp psftp puttygen
PuTTY.app:
	mkdir -p $@
PuTTY.app/Contents: PuTTY.app
	mkdir -p $@
PuTTY.app/Contents/MacOS: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources/PuTTY.icns: PuTTY.app/Contents/Resources putty.icns
	cp putty.icns $@
PuTTY.app/Contents/Info.plist: PuTTY.app/Contents/Resources info.plist
	cp info.plist $@
PuTTY: PuTTY.app/Contents/MacOS/PuTTY \
		PuTTY.app/Contents/Resources/PuTTY.icns \
		PuTTY.app/Contents/Info.plist $(PuTTY_extra)

PuTTY.app/Contents/MacOS/PuTTY: PuTTY.app/Contents/MacOS be_all.o config.o \
		cproxy.o dialog.o fromucs.o ldisc.o ldiscucs.o localenc.o \
		logging.o macenc.o mimeenc.o minibidi.o misc.o osxctrls.o \
		osxdlg.o osxmain.o osxsel.o osxwin.o pinger.o portfwd.o \
		proxy.o raw.o rlogin.o sbcs.o sbcsdat.o settings.o slookup.o \
		ssh.o sshaes.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
		sshdes.o sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o \
		sshrsa.o sshsh512.o sshsha.o sshzlib.o telnet.o terminal.o \
		testback.o time.o timing.o toucs.o tree234.o utf8.o ux_x11.o \
		uxagentc.o uxcfg.o uxmisc.o uxnet.o uxnoise.o uxprint.o \
		uxproxy.o uxpty.o uxsel.o uxsignal.o uxstore.o uxucs.o \
		version.o wcwidth.o wildcard.o x11fwd.o xenc.o
	$(CC) $(MLDFLAGS) -o $@ be_all.o config.o cproxy.o dialog.o \
		fromucs.o ldisc.o ldiscucs.o localenc.o logging.o macenc.o \
		mimeenc.o minibidi.o misc.o osxctrls.o osxdlg.o osxmain.o \
		osxsel.o osxwin.o pinger.o portfwd.o proxy.o raw.o rlogin.o \
		sbcs.o sbcsdat.o settings.o slookup.o ssh.o sshaes.o \
		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
		sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh512.o \
		sshsha.o sshzlib.o telnet.o terminal.o testback.o time.o \
		timing.o toucs.o tree234.o utf8.o ux_x11.o uxagentc.o \
		uxcfg.o uxmisc.o uxnet.o uxnoise.o uxprint.o uxproxy.o \
		uxpty.o uxsel.o uxsignal.o uxstore.o uxucs.o version.o \
		wcwidth.o wildcard.o x11fwd.o xenc.o 

plink: be_all.o cmdline.o cproxy.o ldisc.o logging.o misc.o pinger.o \
		portfwd.o proxy.o raw.o rlogin.o settings.o ssh.o sshaes.o \
		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
		sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh512.o \
		sshsha.o sshzlib.o telnet.o time.o timing.o tree234.o \
		ux_x11.o uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o \
		uxplink.o uxproxy.o uxsel.o uxsignal.o uxstore.o version.o \
		wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_all.o cmdline.o cproxy.o ldisc.o \
		logging.o misc.o pinger.o portfwd.o proxy.o raw.o rlogin.o \
		settings.o ssh.o sshaes.o sshblowf.o sshbn.o sshcrc.o \
		sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh512.o sshsha.o sshzlib.o telnet.o \
		time.o timing.o tree234.o ux_x11.o uxagentc.o uxcons.o \
		uxmisc.o uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o \
		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o 

pscp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pinger.o \
		portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o sshaes.o \
		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
		sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh512.o \
		sshsha.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
		uxcons.o uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o \
		uxsftp.o uxstore.o version.o wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
		logging.o misc.o pinger.o portfwd.o proxy.o pscp.o \
		settings.o sftp.o ssh.o sshaes.o sshblowf.o sshbn.o sshcrc.o \
		sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh512.o sshsha.o sshzlib.o time.o \
		timing.o tree234.o uxagentc.o uxcons.o uxmisc.o uxnet.o \
		uxnoise.o uxproxy.o uxsel.o uxsftp.o uxstore.o version.o \
		wildcard.o x11fwd.o 

psftp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pinger.o \
		portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o sshaes.o \
		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
		sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh512.o \
		sshsha.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
		uxcons.o uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o \
		uxsftp.o uxstore.o version.o wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
		logging.o misc.o pinger.o portfwd.o proxy.o psftp.o \
		settings.o sftp.o ssh.o sshaes.o sshblowf.o sshbn.o sshcrc.o \
		sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh512.o sshsha.o sshzlib.o time.o \
		timing.o tree234.o uxagentc.o uxcons.o uxmisc.o uxnet.o \
		uxnoise.o uxproxy.o uxsel.o uxsftp.o uxstore.o version.o \
		wildcard.o x11fwd.o 

puttygen: cmdgen.o import.o misc.o notiming.o sshaes.o sshbn.o sshdes.o \
		sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o sshrand.o \
		sshrsa.o sshrsag.o sshsh512.o sshsha.o time.o tree234.o \
		uxcons.o uxgen.o uxmisc.o uxnoise.o uxstore.o version.o
	$(CC) $(ULDFLAGS) -o $@ cmdgen.o import.o misc.o notiming.o sshaes.o \
		sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o \
		sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh512.o sshsha.o \
		time.o tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o \
		uxstore.o version.o 

be_all.o: ../be_all.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
be_none.o: ../be_none.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
be_nossh.o: ../be_nossh.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \
		../misc.h ../puttymem.h ../int64.h ../windows/winstuff.h \
		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
		../tree234.h ../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
cmdline.o: ../cmdline.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
config.o: ../config.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
		../network.h ../misc.h ../windows/winstuff.h \
		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
cproxy.o: ../cproxy.c ../putty.h ../ssh.h ../network.h ../proxy.h \
		../puttyps.h ../misc.h ../puttymem.h ../int64.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
dialog.o: ../dialog.c ../putty.h ../dialog.h ../puttyps.h ../network.h \
		../misc.h ../windows/winstuff.h ../mac/macstuff.h \
		../macosx/osx.h ../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
fromucs.o: ../charset/fromucs.c ../charset/charset.h ../charset/internal.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
gtkcfg.o: ../unix/gtkcfg.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
		../network.h ../misc.h ../windows/winstuff.h \
		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
gtkcols.o: ../unix/gtkcols.c ../unix/gtkcols.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
gtkdlg.o: ../unix/gtkdlg.c ../unix/gtkcols.h ../unix/gtkpanel.h ../putty.h \
		../storage.h ../dialog.h ../tree234.h ../puttyps.h \
		../network.h ../misc.h ../windows/winstuff.h \
		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
gtkpanel.o: ../unix/gtkpanel.c ../unix/gtkpanel.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
gtkwin.o: ../unix/gtkwin.c ../putty.h ../terminal.h ../puttyps.h \
		../network.h ../misc.h ../tree234.h ../windows/winstuff.h \

## putty 0.59

=== macosx/Makefile ===
# Makefile for putty under Mac OS X.
#
# This file was created by `mkfiles.pl' from the `Recipe' file.
# DO NOT EDIT THIS FILE DIRECTLY; edit Recipe or mkfiles.pl instead.
#
# Extra options you can set:
#
#  - VER="-DSNAPSHOT=1999-01-25 -DSVN_REV=1234"
#      Generates executables whose About box report them as being a
#      development snapshot. SVN_REV is a Subversion revision number.
#
#  - VER=-DRELEASE=0.43
#      Generates executables whose About box report them as being a
#      release version.
#
#  - COMPAT=-DAUTO_WINSOCK (Windows only)
#      Causes PuTTY to assume that <windows.h> includes its own WinSock
#      header file, so that it won't try to include <winsock.h>.
#
#  - COMPAT=-DWINSOCK_TWO (Windows only)
#      Causes the PuTTY utilities to include <winsock2.h> instead of
#      <winsock.h>, except Plink which _needs_ WinSock 2 so it already
#      does this.
#
#  - COMPAT=-DNO_SECURITY (Windows only)
#      Disables Pageant's use of <aclapi.h>, which is not available
#      with some development environments (such as older versions of
#      the Cygwin/mingw GNU toolchain). This means that Pageant
#      won't care about the local user ID of processes accessing it; a
#      version of Pageant built with this option will therefore refuse
#      to run under NT-series OSes on security grounds (although it
#      will run fine on Win95-series OSes where there is no access
#      control anyway).
#
#  - COMPAT=-DNO_MULTIMON (Windows only)
#      Disables PuTTY's use of <multimon.h>, which is not available
#      with some development environments. This means that PuTTY's
#      full-screen mode (configurable to work on Alt-Enter) will
#      not behave usefully in a multi-monitor environment.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <multimon.h> is
#      known not to be available in Cygwin.
#
#  - COMPAT=-DNO_HTMLHELP (Windows only)
#      Disables PuTTY's use of <htmlhelp.h>, which is not available
#      with some development environments. The resulting binary
#      will only look for an old-style WinHelp file (.HLP/.CNT), and
#      will ignore any .CHM file.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <htmlhelp.h> is
#      known not to be available in Cygwin.
#
#  - RCFL=-DNO_MANIFESTS (Windows only)
#      Disables inclusion of XML application manifests in the PuTTY
#      binaries. This may be necessary to build for 64-bit Windows;
#      the manifests are only included to use the XP GUI style on
#      Windows XP, and the architecture tags are a lie on 64-bit.
#
#  - COMPAT=-DNO_IPV6
#      Disables PuTTY's ability to make IPv6 connections, enabling
#      it to compile under development environments which do not
#      support IPv6 in their header files.
#
#  - COMPAT=-DMSVC4 (Windows only)
#  - RCFL=-DMSVC4
#      Makes a couple of minor changes so that PuTTY compiles using
#      MSVC 4. You will also need -DNO_SECURITY and -DNO_MULTIMON.
#
#  - RCFL=-DASCIICTLS (Windows only)
#      Uses ASCII rather than Unicode to specify the tab control in
#      the resource file. Probably most useful when compiling with
#      Cygnus/mingw32, whose resource compiler may have less of a
#      problem with it.
#
#  - XFLAGS=-DTELNET_DEFAULT
#      Causes PuTTY to default to the Telnet protocol (in the absence
#      of Default Settings and so on to the contrary). Normally PuTTY
#      will default to SSH.
#
#  - XFLAGS=-DDEBUG
#      Causes PuTTY to enable internal debugging.
#
#  - XFLAGS=-DMALLOC_LOG
#      Causes PuTTY to emit a file called putty_mem.log, logging every
#      memory allocation and free, so you can track memory leaks.
#
#  - XFLAGS=-DMINEFIELD (Windows only)
#      Causes PuTTY to use a custom memory allocator, similar in
#      concept to Electric Fence, in place of regular malloc(). Wastes
#      huge amounts of RAM, but should cause heap-corruption bugs to
#      show up as GPFs at the point of failure rather than appearing
#      later on as second-level damage.
#
CC = $(TOOLPATH)gcc

CFLAGS = -O2 -Wall -Werror -g -I.././ -I../charset/ -I../windows/ -I../unix/ \
		-I../mac/ -I../macosx/
MLDFLAGS = -framework Cocoa
ULDFLAGS =

CFLAGS += -DMACOSX

all: PuTTY plink pscp psftp puttygen
PuTTY.app:
	mkdir -p $@
PuTTY.app/Contents: PuTTY.app
	mkdir -p $@
PuTTY.app/Contents/MacOS: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources/PuTTY.icns: PuTTY.app/Contents/Resources putty.icns
	cp putty.icns $@
PuTTY.app/Contents/Info.plist: PuTTY.app/Contents/Resources info.plist
	cp info.plist $@
PuTTY: PuTTY.app/Contents/MacOS/PuTTY \
		PuTTY.app/Contents/Resources/PuTTY.icns \
		PuTTY.app/Contents/Info.plist $(PuTTY_extra)

PuTTY.app/Contents/MacOS/PuTTY: PuTTY.app/Contents/MacOS be_all_s.o config.o \
		cproxy.o dialog.o fromucs.o ldisc.o ldiscucs.o localenc.o \
		logging.o macenc.o mimeenc.o minibidi.o misc.o osxctrls.o \
		osxdlg.o osxmain.o osxsel.o osxwin.o pinger.o portfwd.o \
		proxy.o raw.o rlogin.o sbcs.o sbcsdat.o sercfg.o settings.o \
		slookup.o ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o \
		sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o \
		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
		sshzlib.o telnet.o terminal.o testback.o time.o timing.o \
		toucs.o tree234.o utf8.o ux_x11.o uxagentc.o uxcfg.o \
		uxmisc.o uxnet.o uxnoise.o uxprint.o uxproxy.o uxpty.o \
		uxsel.o uxser.o uxsignal.o uxstore.o uxucs.o version.o \
		wcwidth.o wildcard.o x11fwd.o xenc.o
	$(CC) $(MLDFLAGS) -o $@ be_all_s.o config.o cproxy.o dialog.o \
		fromucs.o ldisc.o ldiscucs.o localenc.o logging.o macenc.o \
		mimeenc.o minibidi.o misc.o osxctrls.o osxdlg.o osxmain.o \
		osxsel.o osxwin.o pinger.o portfwd.o proxy.o raw.o rlogin.o \
		sbcs.o sbcsdat.o sercfg.o settings.o slookup.o ssh.o \
		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
		sshdes.o sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o \
		sshrsa.o sshsh256.o sshsh512.o sshsha.o sshzlib.o telnet.o \
		terminal.o testback.o time.o timing.o toucs.o tree234.o \
		utf8.o ux_x11.o uxagentc.o uxcfg.o uxmisc.o uxnet.o \
		uxnoise.o uxprint.o uxproxy.o uxpty.o uxsel.o uxser.o \
		uxsignal.o uxstore.o uxucs.o version.o wcwidth.o wildcard.o \
		x11fwd.o xenc.o 

plink: be_all_s.o cmdline.o cproxy.o ldisc.o logging.o misc.o pinger.o \
		portfwd.o proxy.o raw.o rlogin.o settings.o ssh.o sshaes.o \
		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
		sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
		sshsh256.o sshsh512.o sshsha.o sshzlib.o telnet.o time.o \
		timing.o tree234.o ux_x11.o uxagentc.o uxcons.o uxmisc.o \
		uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o uxser.o \
		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_all_s.o cmdline.o cproxy.o ldisc.o \
		logging.o misc.o pinger.o portfwd.o proxy.o raw.o rlogin.o \
		settings.o ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o \
		sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o \
		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
		sshzlib.o telnet.o time.o timing.o tree234.o ux_x11.o \
		uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o uxplink.o \
		uxproxy.o uxsel.o uxser.o uxsignal.o uxstore.o version.o \
		wildcard.o x11fwd.o 

pscp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pinger.o \
		portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o sshaes.o \
		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
		sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
		sshsh256.o sshsh512.o sshsha.o sshzlib.o time.o timing.o \
		tree234.o uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o \
		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
		x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
		logging.o misc.o pinger.o portfwd.o proxy.o pscp.o \
		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o \
		sshsha.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
		uxcons.o uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o \
		uxsftp.o uxstore.o version.o wildcard.o x11fwd.o 

psftp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pinger.o \
		portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o sshaes.o \
		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
		sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
		sshsh256.o sshsh512.o sshsha.o sshzlib.o time.o timing.o \
		tree234.o uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o \
		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
		x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
		logging.o misc.o pinger.o portfwd.o proxy.o psftp.o \
		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o \
		sshsha.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
		uxcons.o uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o \
		uxsftp.o uxstore.o version.o wildcard.o x11fwd.o 

puttygen: cmdgen.o import.o misc.o notiming.o sshaes.o sshbn.o sshdes.o \
		sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o sshrand.o \
		sshrsa.o sshrsag.o sshsh512.o sshsha.o time.o tree234.o \
		uxcons.o uxgen.o uxmisc.o uxnoise.o uxstore.o version.o
	$(CC) $(ULDFLAGS) -o $@ cmdgen.o import.o misc.o notiming.o sshaes.o \
		sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o \
		sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh512.o sshsha.o \
		time.o tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o \
		uxstore.o version.o 

be_all.o: ../be_all.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
be_all_s.o: ../be_all_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
be_none.o: ../be_none.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
be_nos_s.o: ../be_nos_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
be_nossh.o: ../be_nossh.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \
		../misc.h ../puttymem.h ../int64.h ../windows/winstuff.h \
		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
		../tree234.h ../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
cmdline.o: ../cmdline.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
		../unix/unix.h ../puttymem.h ../tree234.h \
		../windows/winhelp.h ../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
config.o: ../config.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
		../network.h ../misc.h ../windows/winstuff.h \
		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h

## putty 0.60

=== doc/Makefile ===
--- 
+++ 
@@ -46,8 +46,16 @@
 index.html: $(INPUTS)
 	$(HALIBUT) --text --html --winhelp $(INPUTS)
 
+# During formal builds it's useful to be able to build this one alone.
+putty.hlp: $(INPUTS)
+	$(HALIBUT) --winhelp $(INPUTS)
+
 putty.info: $(INPUTS)
 	$(HALIBUT) --info $(INPUTS)
+
+chm: putty.hhp
+putty.hhp: $(INPUTS) chm.but
+	$(HALIBUT) --html $(INPUTS) chm.but
 
 MKMAN = $(HALIBUT) --man=$@ mancfg.but $<
 MANPAGES = putty.1 puttygen.1 plink.1 pscp.1 psftp.1 puttytel.1 pterm.1
@@ -61,5 +69,7 @@
 puttytel.1: man-ptel.but mancfg.but; $(MKMAN)
 pterm.1: man-pter.but mancfg.but; $(MKMAN)
 
-clean:
-	rm -f *.html *.txt *.hlp *.cnt *.1 *.info vstr.but
+mostlyclean:
+	rm -f *.html *.txt *.hlp *.cnt *.1 *.info vstr.but *.hh[pck]
+clean: mostlyclean
+	rm -f *.chm

=== macosx/Makefile ===
--- 
+++ 
@@ -50,7 +50,8 @@
 #
 #      Note that this definition is always enabled in the Cygwin
 #      build, since at the time of writing this <htmlhelp.h> is
-#      known not to be available in Cygwin.
+#      known not to be available in Cygwin (although you can use
+#      the htmlhelp.h supplied with HTML Help Workshop).
 #
 #  - RCFL=-DNO_MANIFESTS (Windows only)
 #      Disables inclusion of XML application manifests in the PuTTY
@@ -212,39 +213,37 @@
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 be_all_s.o: ../be_all_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 be_none.o: ../be_none.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 be_nos_s.o: ../be_nos_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 be_nossh.o: ../be_nossh.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \
 		../misc.h ../puttymem.h ../int64.h ../windows/winstuff.h \
 		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
 		../tree234.h ../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 cmdline.o: ../cmdline.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(XFLAGS) $(CFLAGS) -c $<
+	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 config.o: ../config.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
 		../network.h ../misc.h ../windows/winstuff.h \
 		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
-		../puttymem.h ../tree234.h ../windows/winhelp.h \
-		../charset/charset.h

## putty 0.60+2009-08

=== macosx/Makefile ===
--- 
+++ 
@@ -64,6 +64,10 @@
 #      it to compile under development environments which do not
 #      support IPv6 in their header files.
 #
+#  - COMPAT=-DNO_GSSAPI
+#      Disables PuTTY's ability to use GSSAPI functions for
+#      authentication and key exchange.
+#
 #  - COMPAT=-DMSVC4 (Windows only)
 #  - RCFL=-DMSVC4
 #      Makes a couple of minor changes so that PuTTY compiles using
@@ -129,7 +133,7 @@
 		sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o \
 		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
 		sshzlib.o telnet.o terminal.o testback.o time.o timing.o \
-		toucs.o tree234.o utf8.o ux_x11.o uxagentc.o uxcfg.o \
+		toucs.o tree234.o utf8.o ux_x11.o uxagentc.o uxcfg.o uxgss.o \
 		uxmisc.o uxnet.o uxnoise.o uxprint.o uxproxy.o uxpty.o \
 		uxsel.o uxser.o uxsignal.o uxstore.o uxucs.o version.o \
 		wcwidth.o wildcard.o x11fwd.o xenc.o
@@ -142,7 +146,7 @@
 		sshdes.o sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o \
 		sshrsa.o sshsh256.o sshsh512.o sshsha.o sshzlib.o telnet.o \
 		terminal.o testback.o time.o timing.o toucs.o tree234.o \
-		utf8.o ux_x11.o uxagentc.o uxcfg.o uxmisc.o uxnet.o \
+		utf8.o ux_x11.o uxagentc.o uxcfg.o uxgss.o uxmisc.o uxnet.o \
 		uxnoise.o uxprint.o uxproxy.o uxpty.o uxsel.o uxser.o \
 		uxsignal.o uxstore.o uxucs.o version.o wcwidth.o wildcard.o \
 		x11fwd.o xenc.o 
@@ -152,62 +156,63 @@
 		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
 		sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
 		sshsh256.o sshsh512.o sshsha.o sshzlib.o telnet.o time.o \
-		timing.o tree234.o ux_x11.o uxagentc.o uxcons.o uxmisc.o \
-		uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o uxser.o \
-		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o
+		timing.o tree234.o ux_x11.o uxagentc.o uxcons.o uxgss.o \
+		uxmisc.o uxnet.o uxnoise.o uxplink.o uxproxy.o uxsel.o \
+		uxser.o uxsignal.o uxstore.o version.o wildcard.o x11fwd.o
 	$(CC) $(ULDFLAGS) -o $@ be_all_s.o cmdline.o cproxy.o ldisc.o \
 		logging.o misc.o pinger.o portfwd.o proxy.o raw.o rlogin.o \
 		settings.o ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o \
 		sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o sshmd5.o \
 		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
 		sshzlib.o telnet.o time.o timing.o tree234.o ux_x11.o \
-		uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o uxplink.o \
-		uxproxy.o uxsel.o uxser.o uxsignal.o uxstore.o version.o \
-		wildcard.o x11fwd.o 
+		uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o \
+		uxplink.o uxproxy.o uxsel.o uxser.o uxsignal.o uxstore.o \
+		version.o wildcard.o x11fwd.o 
 
 pscp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pinger.o \
 		portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o sshaes.o \
 		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
 		sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
 		sshsh256.o sshsh512.o sshsha.o sshzlib.o time.o timing.o \
-		tree234.o uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o \
-		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
-		x11fwd.o
+		tree234.o uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o \
+		uxnoise.o uxproxy.o uxsel.o uxsftp.o uxstore.o version.o \
+		wildcard.o x11fwd.o
 	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
 		logging.o misc.o pinger.o portfwd.o proxy.o pscp.o \
 		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
 		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
 		sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o \
 		sshsha.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
-		uxcons.o uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o \
-		uxsftp.o uxstore.o version.o wildcard.o x11fwd.o 
+		uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxproxy.o \
+		uxsel.o uxsftp.o uxstore.o version.o wildcard.o x11fwd.o 
 
 psftp: be_none.o cmdline.o cproxy.o int64.o logging.o misc.o pinger.o \
 		portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o sshaes.o \
 		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
 		sshdh.o sshdss.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
 		sshsh256.o sshsh512.o sshsha.o sshzlib.o time.o timing.o \
-		tree234.o uxagentc.o uxcons.o uxmisc.o uxnet.o uxnoise.o \
-		uxproxy.o uxsel.o uxsftp.o uxstore.o version.o wildcard.o \
-		x11fwd.o
+		tree234.o uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o \
+		uxnoise.o uxproxy.o uxsel.o uxsftp.o uxstore.o version.o \
+		wildcard.o x11fwd.o
 	$(CC) $(ULDFLAGS) -o $@ be_none.o cmdline.o cproxy.o int64.o \
 		logging.o misc.o pinger.o portfwd.o proxy.o psftp.o \
 		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
 		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
 		sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o \
 		sshsha.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
-		uxcons.o uxmisc.o uxnet.o uxnoise.o uxproxy.o uxsel.o \
-		uxsftp.o uxstore.o version.o wildcard.o x11fwd.o 
+		uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxproxy.o \
+		uxsel.o uxsftp.o uxstore.o version.o wildcard.o x11fwd.o 
 
 puttygen: cmdgen.o import.o misc.o notiming.o sshaes.o sshbn.o sshdes.o \
 		sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o sshrand.o \
-		sshrsa.o sshrsag.o sshsh512.o sshsha.o time.o tree234.o \
-		uxcons.o uxgen.o uxmisc.o uxnoise.o uxstore.o version.o
+		sshrsa.o sshrsag.o sshsh256.o sshsh512.o sshsha.o time.o \
+		tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o uxstore.o \
+		version.o
 	$(CC) $(ULDFLAGS) -o $@ cmdgen.o import.o misc.o notiming.o sshaes.o \
 		sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o \
-		sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh512.o sshsha.o \
-		time.o tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o \
-		uxstore.o version.o 
+		sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh256.o sshsh512.o \
+		sshsha.o time.o tree234.o uxcons.o uxgen.o uxmisc.o \
+		uxnoise.o uxstore.o version.o 
 
 be_all.o: ../be_all.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
@@ -235,15 +240,11 @@
 		../windows/winhelp.h ../charset/charset.h
 	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \
-		../misc.h ../puttymem.h ../int64.h ../windows/winstuff.h \
-		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \
-		../tree234.h ../windows/winhelp.h ../charset/charset.h
+		../misc.h ../puttymem.h ../tree234.h ../int64.h \
+		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
+		../unix/unix.h ../windows/winhelp.h ../charset/charset.h
 	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
 cmdline.o: ../cmdline.c ../putty.h ../puttyps.h ../network.h ../misc.h \
 		../windows/winstuff.h ../mac/macstuff.h ../macosx/osx.h \
 		../unix/unix.h ../puttymem.h ../tree234.h \
 		../windows/winhelp.h ../charset/charset.h
-	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
-config.o: ../config.c ../putty.h ../dialog.h ../storage.h ../puttyps.h \
-		../network.h ../misc.h ../windows/winstuff.h \
-		../mac/macstuff.h ../macosx/osx.h ../unix/unix.h \

## putty 0.60+2010-02-20

=== debian/changelog ===
putty (0.60+2010-02-20-1+squeeze4) squeeze-lts; urgency=medium

  * Non-maintainer upload by the Squeeze LTS team
  * More robust control sequence parameter handling, including:
    - CVE-2015-5309: Fix a potentially memory-corrupting integer overflow in
      the handling of the ECH (erase characters) control sequence in the
      terminal emulator.

 -- Ben Hutchings <ben@decadent.org.uk>  Tue, 24 Nov 2015 01:20:47 +0000

putty (0.60+2010-02-20-1+squeeze3) squeeze-lts; urgency=high

  * Backport from upstream:
    - MATTA-2015-002: Enforce acceptable range for Diffie-Hellman server
      value.
    - Fix an erroneous length field in SSH-1 key load.
    - CVE-2015-2157: Fix failure to clear sensitive private key information
      from memory (closes: #779488).

 -- Colin Watson <cjwatson@debian.org>  Sun, 15 Mar 2015 17:44:52 +0000

putty (0.60+2010-02-20-1+squeeze2) oldstable-security; urgency=high

  * CVE-2011-4607: Passwords were left in memory using SSH
    keyboard-interactive auth.
  * CVE-2013-4206: Buffer underrun in modmul could corrupt the heap.
  * CVE-2013-4852: Negative string length in public-key signatures could
    cause integer overflow and overwrite all of memory (closes: #718779).
  * CVE-2013-4207: Non-coprime values in DSA signatures can cause buffer
    overflow in modular inverse.
  * CVE-2013-4208: Private keys were left in memory after being used by
    PuTTY tools.
  * Backport some general proactive potentially-security-relevant tightening
    from upstream.

 -- Colin Watson <cjwatson@debian.org>  Thu, 08 Aug 2013 23:37:19 +0100

putty (0.60+2010-02-20-1) unstable; urgency=low

  * New experimental development snapshot.
    - Console utilities send prompts to /dev/tty or failing that stderr, not
      to stdout (closes: #422295).
  * Upgrade to debhelper v7.
  * Move documentation from putty-tools to a new putty-doc package (closes:
    #472195).
  * Add a watch file.
  * Convert to source format 3.0 (quilt).  No remaining Debian patches!

 -- Colin Watson <cjwatson@debian.org>  Mon, 22 Feb 2010 01:01:22 +0000

putty (0.60+2009-11-22-1) unstable; urgency=low

  * New experimental development snapshot.
  * Moved to bzr.debian.org; add Vcs-Bzr and Vcs-Browser control fields.

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Jan 2010 14:50:45 +0000

putty (0.60+2009-08-22-3) unstable; urgency=low

  * Use x11.pc when compiling/linking against GTK (closes: #556125).

 -- Colin Watson <cjwatson@debian.org>  Mon, 23 Nov 2009 20:39:22 +0000

putty (0.60+2009-08-22-2) unstable; urgency=low

  * Rebuild manual pages with halibut 1.0+svn20090906-1, fixing option
    markers (see #496063).
  * Stop calling dh_desktop, as it's now a no-op thanks to dpkg triggers.

 -- Colin Watson <cjwatson@debian.org>  Mon, 07 Sep 2009 01:22:17 +0100

putty (0.60+2009-08-22-1) unstable; urgency=low

  * New experimental development snapshot.
    - Fix potential crash on "reget" in psftp.
    - Fix random seed behaviour in the absence of a seed file.
    - Support OpenSSH's method of specifying port numbers in known_hosts.
    - Improve Pango font handling performance.
  * Use dh_install, dh_installman, and dh_lintian, and use some other
    debhelper programs more effectively.
  * Upgrade to debhelper v6.

 -- Colin Watson <cjwatson@debian.org>  Tue, 25 Aug 2009 21:50:05 +0100

putty (0.60+2009-04-05-1) unstable; urgency=low

  * New experimental development snapshot.
    - Stop attempting to make session logs private on Unix. This was
      introduced in r7084 at the same time as sensible permissions when
      writing private key files; however, it causes an assertion failure
      whenever an attempt is made to append to an existing log file on Unix,
      and it's not clear what "is_private" *should* do for append, so revert
      to log file security being the user's responsibility (LP: #212711).
    - Cope with GTK+ 2.0 encoding keypress strings in the current locale
      rather than in ISO-8859-1 (closes: #517535).

 -- Colin Watson <cjwatson@debian.org>  Sun, 05 Apr 2009 22:42:02 +0100

putty (0.60+2009-02-22-1) unstable; urgency=low

  * New experimental development snapshot.
    - Uses GTK+ 2.0 (closes: #516641, LP: #271277) and as a result supports
      Unicode window titles (LP: #48781).
    - Fixes handling of trailing CR in key files (closes: #414784).
  * Disabled upstream Kerberos support for now, as it produces unwanted
    linkage in pterm and other binaries.

 -- Colin Watson <cjwatson@debian.org>  Mon, 23 Feb 2009 10:11:54 +0000

putty (0.60-4) unstable; urgency=low

  * Build-depend on x11proto-core-dev rather than x-dev (thanks, Lintian).
  * Backport from upstream (r8150, Jacob Nevins; closes: #503186,
    LP: #67488):
    - Fix for portfwd-addr-family: on Unix, when a tunnel is specified as
      "Auto" (rather than IPv4 or IPv6-only; this is the default), try to
      open up listening sockets on both address families, rather than
      (unhelpfully) just IPv6. (And don't open one if the other can't be
      bound, in a nod to CVE-2008-1483.) Based on a patch from Ben A L
      Jemmett.
  * Avoid problems with the -D_FORTIFY_SOURCE=2 default on Ubuntu by
    explicitly ignoring results from a number of calls to read, write, and
    fwrite. (This is pretty ham-handed and I've asked upstream whether they
    have any better ideas for any of these.)

 -- Colin Watson <cjwatson@debian.org>  Sun, 16 Nov 2008 22:06:59 +0000

putty (0.60-3) unstable; urgency=low

  * Move putty to Applications/Network/Communication menu sub-section.
  * Use dh_desktop.

 -- Colin Watson <cjwatson@debian.org>  Wed, 28 May 2008 09:28:32 +0100

putty (0.60-2) unstable; urgency=low

  * Update to section structure from menu 2.1.35.

 -- Colin Watson <cjwatson@debian.org>  Thu, 05 Jul 2007 12:19:47 +0100

putty (0.60-1) unstable; urgency=low

  * New upstream release (closes: #422935).
    - Pressing Ctrl+Break now sends a serial break signal in the serial back


=== debian/control ===
Source: putty
Section: net
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 3.5.9
Build-Depends: debhelper (>= 7.0.50), pkg-config, libgtk2.0-dev, x11proto-core-dev, libx11-dev, imagemagick, python
Vcs-Bzr: http://bzr.debian.org/pkg-ssh/putty/trunk
Vcs-Browser: http://bzr.debian.org/loggerhead/pkg-ssh/putty/trunk

Package: pterm
Section: x11
Architecture: any
Depends: ${shlibs:Depends}
Suggests: putty-doc
Provides: x-terminal-emulator
Description: PuTTY terminal emulator
 This is an X terminal emulator based on the popular Windows ssh client,
 PuTTY. It supports xterm escape sequences, plus some Linux console
 sequences for colour palette configuration and some DECterm sequences for
 title bar control, and with an appropriate font it supports the UTF-8
 encoding of Unicode. It also has some nifty features like rectangular
 selection and NetHack keypad mode.

Package: putty
Architecture: any
Depends: ${shlibs:Depends}, putty-tools
Suggests: putty-doc
Description: Telnet/SSH client for X
 This is the Unix port of the popular Windows ssh client, PuTTY. It supports
 flexible terminal setup, mid-session reconfiguration using Ctrl-rightclick,
 multiple X11 authentication protocols, and various other interesting things
 not provided by ssh in an xterm.

Package: putty-tools
Architecture: any
Depends: ${shlibs:Depends}
Suggests: putty-doc
Description: command-line tools for SSH, SCP, and SFTP
 This package provides four command-line tools from the PuTTY suite that
 allow various kinds of secure interaction with remote systems.
 .
 Plink (PuTTY Link) connects to a remote system via SSH, Telnet, or rlogin,
 and either starts an interactive session or runs a batch process. It
 supports the usual SSH features like port forwarding, X11 forwarding,
 SOCKS, and compression.
 .
 PSCP (PuTTY Secure Copy) transfers files securely between systems using an
 SSH connection. It works with both SSH protocol 1 and protocol 2.
 .
 PSFTP (PuTTY SFTP client) transfers files securely between systems using
 the SSH file transfer protocol, which is specific to SSH protocol 2. In
 interactive mode its interface is much like the traditional Unix FTP
 client, although it can also operate in batch mode.
 .
 PuTTYgen generates SSH public and private key pairs in any of a number of
 formats, including those usable by PuTTY, OpenSSH, and ssh.com.
 .
 All these utilities can make use of PuTTY's saved sessions where
 appropriate.

Package: putty-doc
Section: doc
Architecture: all
Description: PuTTY HTML documentation
 Full HTML documentation for the PuTTY suite of programs (PuTTY, pterm,
 Plink, PSCP, PSFTP, and PuTTYgen).

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@

ptermtmp = debian/pterm
puttytmp = debian/putty

version := $(shell dpkg-parsechangelog | grep '^Version:' | \
		   sed -e 's/.*\([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]\).*/\1/')

# If a snapshot, supply an explicit version. Release tarballs work it out
# for themselves.
ifeq (,$(findstring Version,$(version)))
verdef := VER=-DSNAPSHOT="$(version)"
endif

override_dh_auto_build:
	cd unix && $(MAKE) -f Makefile.gtk $(verdef) COMPAT=-DNO_GSSAPI \
		plink pscp psftp pterm putty puttygen
	$(MAKE) -C icons cicons pngs

override_dh_auto_clean:
	cd unix && $(MAKE) -f Makefile.gtk clean
	$(MAKE) -C icons clean

override_dh_install:
	dh_install
	install -m644 icons/xpmpterm.c $(ptermtmp)/usr/share/pixmaps/pterm.xpm
	install -m644 icons/xpmputty.c $(puttytmp)/usr/share/pixmaps/putty.xpm
	install -m644 icons/pterm-32.png \
		      $(ptermtmp)/usr/share/pixmaps/pterm.png
	install -m644 icons/putty-32.png \
		      $(puttytmp)/usr/share/pixmaps/putty.png

override_dh_compress:
	dh_compress -X.py

override_dh_fixperms:
	dh_fixperms
	chgrp utmp $(ptermtmp)/usr/bin/pterm
	chmod g+s $(ptermtmp)/usr/bin/pterm
